#! /usr/local/bin/ruby

# $Id: dice.rb,v 1.1.1.1 2002/09/10 12:07:22 ray_aero Exp $

=begin
Ϣѥ饹

TODO
 * ϰϤνܤΥб(飵ʤ)
=end

begin
  require 'random/mersenne_twister'
  MTLOAD = true
rescue LoadError
  MTLOAD = false
end

class Dice
  if MTLOAD
    MT = Random::MersenneTwister
  else
    class TempMT
      def initialize( seed ); end
      def rand( val ); super; end
      def seed(); nil; end
    end
    MT = TempMT
  end

  class DiceResult
    include Comparable

    def initialize( face, results = nil )
=begin
       face : ̿
       results : η(ͤʤ1ĿäȤơʤ餽ΥäȤư)
=end
      # Range of Dice result
      @face = (face.kind_of?(Range) ? face.dup : Range.new(1,face.to_i))
      # Sum of result
      @total = 0
      # Result stream of individual Die
      @stream = Array.new
      # Counts of each face appeared
      @counts = Hash.new( 0 )

      push(results.dup) if results
    end

    attr_reader( :face, :total, :stream, :counts )

    def num() # Returns the number of Dice rolled
      @stream.size
    end

    def push( imp ) # Add a data to Results
=begin
  Integer  Integer ˼ꡢ̥ꥹȤɲä
  κݡǡȤ @face ϰ⤫åԤ
  Ϥ줿ˤҤȤĤǤ⥨顼ǡɲưϹԤʤ
  ˤäưθ(Atom)ݻ롣
=end
      # ǤʤȤϣǤѴ
      imp = Array.new.push(imp) unless imp.kind_of?( Array )

      # ƥݥѿν
      tempArray = Array.new
      tempTotal = 0
      tempCount = Hash.new(0)

      # ǡΥåȥƥݥؤɲ
      imp.each{ |data|
	raise( TypeError, "Argument needs to be 'Integer' or 'Array of Integer'" ) unless data.kind_of?( Integer )
	raise( RangeError, "Data : #{data} is out of face range : #{@face}" ) unless @face.member?(data)

	tempArray.push data
	tempTotal += data
	tempCount[data] += 1
      }

      # ꤬ʤäΤΤؤѹΥޡ
      @stream.concat tempArray
      @total += tempTotal
      tempCount.each{|k,v| @counts[k] += v }

      # ɲä줿ǡ֤
      tempArray
    end

    def consistent?() # Check the consistency
=begin
 ǡå
 @total  @counts Ʒ׻ξȤפƤ true ֤
 ɤ餫פʤä硢ۤɤƤ nil ֤
=end
      t = 0
      c = Hash.new(0)

      @stream.each{ |d|
	t += d
	c[d] += 1
      }

      res = (t == @total) and (c == @counts)
      if !res then
	@total = t
	@counts = c
      end

      res
    end

    def isRangeFace?(); @face.min != 1; end

    def to_str(); "#{self.num()}D%s : #{@total}" % [ isRangeFace?() ? @face.max.to_s : "(#{@face})" ]; end
    def to_ary(); @stream.dup; end
    def to_hash(); @counts.dup; end
    alias to_s to_str
    alias to_a to_ary

    def to_int(); consistent?(); @total.to_i(); end
    alias to_i to_int
    def to_f(); consistent?(); @total.to_f(); end
    def +( x ); convert_to(x) + x; end
    def -( x ); convert_to(x) - x; end
    def *( x ); convert_to(x) * x; end
    def /( x ); convert_to(x) / x; end
    def **( x ); convert_to(x) ** x; end
    def % ( x ); convert_to(x) % x; end
    def +@(); to_i(); end
    def -@(); - to_i(); end
    def <=>( x ); convert_to(x) <=> x; end

    def coerce( x ); [x, Float === x ? to_f : to_i ]; end
    def convert_to( x )
      case x
	when Array
	  res = to_ary()
	when Hash
	  res = to_hash()
	when Numeric, DiceResult
	  res = coerce( x )[1]
	when String
	  res = to_str()
	else
	  res = self
      end

      res
    end

  end # class DiceResult
end # class Dice

class Dice
  # ΰꤹ(ϤȤ)
  C2I_RoundOff = 0 # üڼΤ
  C2I_RollUp   = 1 # üھ夲
  C2I_4Cut5Up  = 2 # ͼθ
  C2I_Centinel = 3 # ʼ(ΰѹݤΥ⡼ֹ)

  @@floatConv = C2I_4Cut5Up
  def self.c2i?(); @@floatConv; end
  def self.c2i= ( mode )
    raise ArgumentError unless Range.new(0, C2I_Centinel, true).member?(mode)

    @@floatConv = mode
  end

  def self.c2i( val )
    raise TypeError unless Numeric === val

    if Float === val
      case @@floatConv
        when C2I_RoundOff
	  val.truncate
	when C2I_RollUp
	  val.ceil
	when C2I_4Cut5Up
	  val.round
      end
    else
      val
    end
  end

  def c2i(val); type().c2i( val ); end
  def c2i?(); type().c2i?(); end
    
  def initialize( num = 1, face = 6, seed = Time.now.to_i )
    @result = nil

    @face = c2i(face)
    @num = c2i(num)
    @mt = MT.new( seed )
  end

  def roll( num = nil, face = nil )
    @num = c2i(num) if num
    @face = c2i(face) if face
    results = DiceResult.new( @face )
    frange = results.face
    @num.times { results.push( @mt.rand(frange.length) + frange.min ) }

    @result = results
  end

  attr_reader( :result )
  attr_reader( :num, :face )

  def num=( val ); @num = c2i( val ); end
  def face=( val ); @face = c2i( val ); end

  def seed(); @mt.seed; end
  def total(); @result.total; end
  def stream(); @result.stream; end

  def self.roll( num, face )
    Dice.new( num, face ).roll
  end

  def self.[] ( num, face )
    roll( num, face )
  end

end # class Dice

if $0 == __FILE__ then
  d = Dice.new
  n = f = nil
  if ARGV.size() > 0 then n = ARGV.shift().to_i; end
  if ARGV.size() > 0 then f = ARGV.shift().to_i; end

  n = 1 if !n
  f = 6 if !f

  puts d.roll( n, f )
end
